/**
 * @author: Sebastian Martens; sebastian@sebastian-martens.de
 * @copyright: Creative Commons. Free to use "as is"
 * @svn: $Id: swfZoomDetection.as 6 2009-12-21 21:14:59Z dinnerout $
 */
package com.nonstatics.swfZoomDetection
{
	import com.nonstatics.jsCallStack.JsCallStack;
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.external.ExternalInterface;
	
	public class swfZoomDetection extends Sprite{
		
		private var _jsCalls:JsCallStack;
		
		private var _setHeight:int;
		private var _setWidth:int;
		
		private var _savedZoomLevel:Number;
		private var _initCall:Boolean = true;
		
		/**
		 * constructor
		 */ 
		public function swfZoomDetection(){
			// init JS function call stack
			this._jsCalls = new JsCallStack();
			this._jsCalls.timerInterval = 30;
			
			this.stage.frameRate = 25;
			this.stage.scaleMode = "noScale";
			
			this.creationCompleteHandler( null );
		}
		
		/**
		 * call javascript to check initial communication and get parameters
		 * @param event:Event - creation complete event
		 */
		private function creationCompleteHandler( event:Event ):void{
			this._jsCalls.addJSCall("swfZoomDetection.swfZoomDetectInit", {}, jsInitHandler );
        }
		
		/**
		 * JavaScript init handler
		 * recieves initialisation parameters and attach handler methods
		 * @param obj:Object - JS Object with init parameters
		 */ 
		private function jsInitHandler( obj:Object ):void{
			this._setHeight = int( obj.setHeight );
			this._setWidth = int( obj.setWidth );
			
			if( Boolean( obj.isOnZoomChangeSet ) ){
				if( int( obj.frameRate ) ){
					this.stage.frameRate = int( obj.frameRate );
				}
				this.addEventListener( Event.ENTER_FRAME, this.enterFrameHandler );
			}
		}
		
		/**
		 * onEnterFrame handler, called on enter frame if onZoomChange is defined
		 * @param evt:Event - enter frame event
		 */ 
		private function enterFrameHandler( evt:Event ):void{
			if( this.getZoomLevel()!=this._savedZoomLevel ){
				this._savedZoomLevel = this.getZoomLevel();
				this._jsCalls.addJSCall("swfZoomDetection.zoomChangeHandler",{
					'scale':this.getZoomLevel(),
					'init': this._initCall
				});
				this._initCall = false;
			}
		}
		
		/**
		 * is browser currently scaled ?! 
		 * @return Boolean true if scaled
		 */ 
		public function isScaled():Boolean{
			return (this.getZoomLevel()!=1);
		}
		
		/**
		 * returns the zoomLevel ( >1 larger scale, <1 smaller scale
		 * @return Number scale value
		 */ 
		public function getZoomLevel():Number{
			return (this.stage.stageHeight/this._setHeight);
		}
	}
}